Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 17409)
@@ -28,4 +28,5 @@
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
+using Tpl = System.Threading.Tasks;
 
 namespace HeuristicLab.Clients.Hive.Administrator.Views {
@@ -33,6 +34,4 @@
   [Content(typeof(Project), IsDefaultView = true)]
   public partial class ProjectView : ItemView {
-    private readonly object locker = new object();
-
     public new Project Content {
       get { return (Project)base.Content; }
@@ -58,27 +57,10 @@
     }
 
-    protected void RegisterControlEvents() {
-      nameTextBox.TextChanged += nameTextBox_TextChanged;
-      nameTextBox.Validating += nameTextBox_Validating;
-      descriptionTextBox.TextChanged += descriptionTextBox_TextChanged;
-      ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
-      startDateTimePicker.ValueChanged += startDateTimePicker_ValueChanged;
-      endDateTimePicker.ValueChanged += endDateTimePicker_ValueChanged;
-      indefiniteCheckBox.CheckedChanged += indefiniteCheckBox_CheckedChanged;
-    }
-
-    protected void DeregisterControlEvents() {
-      nameTextBox.TextChanged -= nameTextBox_TextChanged;
-      nameTextBox.Validating -= nameTextBox_Validating;
-      descriptionTextBox.TextChanged -= descriptionTextBox_TextChanged;
-      ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
-      startDateTimePicker.ValueChanged -= startDateTimePicker_ValueChanged;
-      endDateTimePicker.ValueChanged -= endDateTimePicker_ValueChanged;
-      indefiniteCheckBox.CheckedChanged -= indefiniteCheckBox_CheckedChanged;
-    }
-
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      DeregisterControlEvents();
+      UpdateView();
+    }
+
+    private void UpdateView() {
       if (Content == null) {
         idTextBox.Clear();
@@ -94,207 +76,28 @@
         nameTextBox.Text = Content.Name;
         descriptionTextBox.Text = Content.Description;
-
-        if (AccessClient.Instance.UsersAndGroups != null) {
-          var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
-          if (!Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-          var projectOwnerId = Content.OwnerUserId;
-          ownerComboBox.DataSource = users.OrderBy(x => x.UserName).ToList();
-          ownerComboBox.SelectedItem = users.FirstOrDefault(x => x.Id == projectOwnerId);
-        }
-
+        ownerComboBox.SelectedItem = AccessClient.Instance.UsersAndGroups?.OfType<LightweightUser>().SingleOrDefault(x => x.Id == Content.OwnerUserId);
         createdTextBox.Text = Content.DateCreated.ToString("ddd, dd.MM.yyyy, HH:mm:ss");
         startDateTimePicker.Value = Content.StartDate;
-
+        endDateTimePicker.Value = Content.EndDate.GetValueOrDefault(Content.StartDate);
         indefiniteCheckBox.Checked = !Content.EndDate.HasValue;
-        if (!indefiniteCheckBox.Checked) endDateTimePicker.Value = Content.EndDate.Value;
-        else endDateTimePicker.Value = Content.StartDate;
-        endDateTimePicker.Enabled = !indefiniteCheckBox.Checked;
-      }
-      SetEnabledStateOfControls();
-      RegisterControlEvents();
-    }
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      bool enabled = Content != null && !Locked && !ReadOnly;
-      nameTextBox.Enabled = enabled;
-      descriptionTextBox.Enabled = enabled;
-      ownerComboBox.Enabled = enabled;
-      createdTextBox.Enabled = enabled;
-      startDateTimePicker.Enabled = enabled;
-      endDateTimePicker.Enabled = enabled && Content.EndDate.HasValue;
-      indefiniteCheckBox.Enabled = enabled;
-
-      if (Content != null) {
-        //var parentProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).LastOrDefault();
-        var parentProject = HiveAdminClient.Instance.Projects.FirstOrDefault(x => x.Id == Content.ParentProjectId);
-        if ((!IsAdmin() && (parentProject == null || parentProject.EndDate.HasValue))
-           || (IsAdmin() && parentProject != null && parentProject.EndDate.HasValue)) {
-          indefiniteCheckBox.Enabled = false;
-        }
-
-        if (Content.Id != Guid.Empty && !IsAdmin() && !HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)) {
-          ownerComboBox.Enabled = false;
-          startDateTimePicker.Enabled = false;
-          endDateTimePicker.Enabled = false;
-          indefiniteCheckBox.Enabled = false;
-        }
-      }
-    }
-    #endregion
-
-    #region Event Handlers
-    private void Content_PropertyChanged(object sender, PropertyChangedEventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, PropertyChangedEventArgs>)Content_PropertyChanged, sender, e);
-      else OnContentChanged();
-    }
-
-    private void AccessClient_Instance_Refreshing(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
-      else {
-        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
-        SetEnabledStateOfControls();
-      }
-    }
-
-    private void AccessClient_Instance_Refreshed(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
-      else {
-        Progress.Hide(this);
-        SetEnabledStateOfControls();
-      }
-    }
-
-    private async void ProjectView_Load(object sender, EventArgs e) {
-      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-        action: () => UpdateUsers(),
-        finallyCallback: () => {
-          ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
-          var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
-          if (Content != null && !Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-          var projectOwnerId = Content != null ? Content.OwnerUserId : (Guid?)null;
-          ownerComboBox.DataSource = users.OrderBy(x => x.UserName).ToList();
-          ownerComboBox.SelectedItem = projectOwnerId.HasValue ? users.FirstOrDefault(x => x.Id == projectOwnerId) : null;
-          ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
-        });
-    }
-
-    private void ProjectView_Disposed(object sender, EventArgs e) {
-      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
-    }
-
-    private void nameTextBox_Validating(object sender, CancelEventArgs e) {
-      if (string.IsNullOrEmpty(nameTextBox.Text)) {
-        MessageBox.Show(
-          "Project must have a name.",
-          "HeuristicLab Hive Administrator",
-          MessageBoxButtons.OK,
-          MessageBoxIcon.Error);
-        e.Cancel = true;
-      }
-    }
-
-    private void nameTextBox_TextChanged(object sender, EventArgs e) {
-      if (Content != null && Content.Name != nameTextBox.Text) {
-        DeregisterContentEvents();
-        Content.Name = nameTextBox.Text;
-        RegisterContentEvents();
-      }
-    }
-
-    private void descriptionTextBox_TextChanged(object sender, EventArgs e) {
-      if (Content != null && Content.Description != descriptionTextBox.Text) {
-        DeregisterContentEvents();
-        Content.Description = descriptionTextBox.Text;
-        RegisterContentEvents();
-      }
-    }
-
-    private void ownerComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      var selectedItem = (LightweightUser)ownerComboBox.SelectedItem;
-      var selectedOwnerUserId = selectedItem != null ? selectedItem.Id : Guid.Empty;
-      if (Content != null && Content.OwnerUserId != selectedOwnerUserId) {
-        DeregisterContentEvents();
-        Content.OwnerUserId = selectedOwnerUserId;
-        RegisterContentEvents();
-      }
-    }
-
-    private void startDateTimePicker_ValueChanged(object sender, EventArgs e) {
-      if (Content == null) return;
-      startDateTimePicker.ValueChanged -= startDateTimePicker_ValueChanged;
-
-      if (!IsAdmin()) {
-        var parentProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).LastOrDefault();
-        if (parentProject != null) {
-          if (startDateTimePicker.Value < parentProject.StartDate)
-            startDateTimePicker.Value = parentProject.StartDate;
-        } else {
-          startDateTimePicker.Value = Content.StartDate;
-        }
-      }
-
-      if (!Content.EndDate.HasValue || startDateTimePicker.Value > Content.EndDate)
-        endDateTimePicker.Value = startDateTimePicker.Value;
-      if (Content.StartDate != startDateTimePicker.Value) {
-        DeregisterContentEvents();
-        Content.StartDate = startDateTimePicker.Value;
-        RegisterContentEvents();
-      }
-
-      startDateTimePicker.ValueChanged += startDateTimePicker_ValueChanged;
-    }
-
-    private void endDateTimePicker_ValueChanged(object sender, EventArgs e) {
-      if (Content == null) return;
-      endDateTimePicker.ValueChanged -= endDateTimePicker_ValueChanged;
-
-      if (!IsAdmin()) {
-        var parentProject = HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).LastOrDefault();
-        if (parentProject != null) {
-          if (parentProject.EndDate.HasValue && endDateTimePicker.Value > parentProject.EndDate.Value) {
-            endDateTimePicker.Value = parentProject.EndDate.Value;
-          }
-        } else if (Content.EndDate.HasValue) {
-          endDateTimePicker.Value = Content.EndDate.Value;
-        }
-      }
-
-      if (endDateTimePicker.Value < startDateTimePicker.Value)
-        endDateTimePicker.Value = startDateTimePicker.Value;
-      if (Content.EndDate != endDateTimePicker.Value) {
-        DeregisterContentEvents();
-        Content.EndDate = endDateTimePicker.Value;
-        RegisterContentEvents();
-      }
-
-      endDateTimePicker.ValueChanged += endDateTimePicker_ValueChanged;
-    }
-
-    private void indefiniteCheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (Content == null) return;
-
-      var newEndDate = indefiniteCheckBox.Checked ? (DateTime?)null : endDateTimePicker.Value;
-      endDateTimePicker.Enabled = !indefiniteCheckBox.Checked;
-      if (Content.EndDate != newEndDate) {
-        DeregisterContentEvents();
-        Content.EndDate = newEndDate;
-        RegisterContentEvents();
-      }
-    }
-    #endregion
-
-    #region Helpers
+      }
+    }
+
+    private async Tpl.Task UpdateUsersAsync() {
+      await Tpl.Task.Run(() => UpdateUsers());
+    }
+
     private void UpdateUsers() {
+      // deregister handler to avoid change of content's owner when data source is updated
+      ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
       try {
-        AccessClient.Instance.Refresh();
+        ownerComboBox.DataSource = null;
+        SecurityExceptionUtil.TryAndReportSecurityExceptions(AccessClient.Instance.Refresh);
+        ownerComboBox.DataSource = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>().OrderBy(x => x.UserName).ToList();
       } catch (AnonymousUserException) {
         ShowHiveInformationDialog();
-      }
-    }
-
-    private bool IsAdmin() {
-      return HiveRoles.CheckAdminUserPermissions();
+      } finally {
+        ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
+      }
     }
 
@@ -307,4 +110,171 @@
       }
     }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+
+      bool enabled = Content != null && !Locked && !ReadOnly;
+
+      nameTextBox.Enabled = enabled;
+      descriptionTextBox.Enabled = enabled;
+      ownerComboBox.Enabled = enabled;
+      refreshButton.Enabled = enabled;
+      createdTextBox.Enabled = enabled;
+      startDateTimePicker.Enabled = enabled;
+      endDateTimePicker.Enabled = enabled && Content.EndDate.HasValue && Content.EndDate > Content.StartDate;
+      indefiniteCheckBox.Enabled = enabled;
+
+      if (Content == null) return;
+
+      var parentProject = HiveAdminClient.Instance.Projects.SingleOrDefault(x => x.Id == Content.ParentProjectId);
+      if (parentProject != null && parentProject.EndDate.HasValue)
+        indefiniteCheckBox.Enabled = false;
+
+      if (Content.Id == Guid.Empty) return; // newly created project
+      if (HiveRoles.CheckAdminUserPermissions()) return; // admins can edit any project
+      if (HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)) return; // owner can edit project
+
+      // project was already created and user is neither admin nor owner
+      ownerComboBox.Enabled = false;
+      startDateTimePicker.Enabled = false;
+      endDateTimePicker.Enabled = false;
+      indefiniteCheckBox.Enabled = false;
+    }
+    #endregion
+
+    #region Event Handlers
+    private void ProjectView_Load(object sender, EventArgs e) {
+      Locked = true;
+      try {
+        UpdateUsers();
+        UpdateView();
+      } finally {
+        Locked = false;
+      }
+    }
+
+    private void Content_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      UpdateView();
+    }
+
+    private void nameTextBox_TextChanged(object sender, EventArgs e) {
+      if (Content == null || Content.Name == nameTextBox.Text) return;
+      Content.Name = nameTextBox.Text;
+    }
+
+    private void nameTextBox_Validating(object sender, CancelEventArgs e) {
+      if (!string.IsNullOrEmpty(nameTextBox.Text)) return;
+
+      MessageBox.Show("Project must have a name.", "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+      e.Cancel = true;
+    }
+
+    private void descriptionTextBox_TextChanged(object sender, EventArgs e) {
+      if (Content == null || Content.Description == descriptionTextBox.Text) return;
+      Content.Description = descriptionTextBox.Text;
+    }
+
+    private void ownerComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (Content == null) return;
+
+      var selectedItem = (LightweightUser)ownerComboBox.SelectedItem;
+      var selectedOwnerUserId = selectedItem != null ? selectedItem.Id : Guid.Empty;
+      if (Content.OwnerUserId == selectedOwnerUserId) return;
+
+      Content.OwnerUserId = selectedOwnerUserId;
+    }
+
+    private async void refreshButton_Click(object sender, EventArgs e) {
+      Locked = true;
+      try {
+        await UpdateUsersAsync();
+        UpdateView();
+      } finally {
+        Locked = false;
+      }
+    }
+
+    private void startDateTimePicker_ValueChanged(object sender, EventArgs e) {
+      if (Content == null || Content.StartDate == startDateTimePicker.Value) return;
+
+      string errorMessage = string.Empty;
+
+      var parentProject = HiveAdminClient.Instance.Projects.SingleOrDefault(x => x.Id == Content.ParentProjectId);
+      if (parentProject != null) {
+        if (startDateTimePicker.Value < parentProject.StartDate) {
+          errorMessage = "Project cannot start before its parent project has started.";
+        } else if (startDateTimePicker.Value > parentProject.EndDate) {
+          errorMessage = "Project cannot start after its parent project has ended.";
+        }
+      }
+
+      if (startDateTimePicker.Value > endDateTimePicker.Value) {
+        errorMessage = "Project cannot start after it ends.";
+      }
+
+      if (!string.IsNullOrEmpty(errorMessage)) {
+        MessageBox.Show(errorMessage, "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        startDateTimePicker.Value = Content.StartDate;
+      }
+
+      Content.StartDate = startDateTimePicker.Value;
+    }
+
+    private void endDateTimePicker_ValueChanged(object sender, EventArgs e) {
+      if (Content == null || Content.EndDate == endDateTimePicker.Value || Content.StartDate == endDateTimePicker.Value) return;
+
+      string errorMessage = string.Empty;
+
+      var parentProject = HiveAdminClient.Instance.Projects.SingleOrDefault(x => x.Id == Content.ParentProjectId);
+      if (parentProject != null) {
+        if (endDateTimePicker.Value > parentProject.EndDate) {
+          errorMessage = "Project cannot end after its parent project has ended.";
+        } else if (endDateTimePicker.Value < parentProject.StartDate) {
+          errorMessage = "Project cannot end before its parent project has started.";
+        }
+      }
+
+      if (endDateTimePicker.Value < startDateTimePicker.Value) {
+        errorMessage = "Project cannot end after it starts.";
+      }
+
+      if (!string.IsNullOrEmpty(errorMessage)) {
+        MessageBox.Show(errorMessage, "HeuristicLab Hive Administrator", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        endDateTimePicker.Value = Content.EndDate.GetValueOrDefault(Content.StartDate);
+      }
+
+      Content.EndDate = endDateTimePicker.Value;
+    }
+
+    private void indefiniteCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (Content == null) return;
+
+      var newEndDate = indefiniteCheckBox.Checked ? (DateTime?)null : endDateTimePicker.Value;
+
+      if (Content.EndDate == newEndDate) return;
+      Content.EndDate = newEndDate;
+
+      endDateTimePicker.Enabled = !indefiniteCheckBox.Checked;
+    }
+
+    private void AccessClient_Instance_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
+        return;
+      }
+
+      Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
+      SetEnabledStateOfControls();
+    }
+
+    private void AccessClient_Instance_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
+        return;
+      }
+
+      Progress.Hide(this);
+      SetEnabledStateOfControls();
+    }
     #endregion
   }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveJobManagerView.cs	(revision 17409)
@@ -144,6 +144,7 @@
       if (Content != null && Content.Jobs != null) {
         // clear hive client only if it is not displayed by any other content view (i.e. job manager)
-        var contentViews = MainFormManager.MainForm.Views.OfType<IContentView>();
-        if (contentViews.All(x => x.Content != Content || x == this))
+        var contentViews = MainFormManager.MainForm.Views.OfType<IContentView>()
+          .Where(v => v.Content == Content && v != this);
+        if (!contentViews.Any())
           Content.ClearHiveClient();
 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 17409)
@@ -25,5 +25,4 @@
 using System.Linq;
 using System.Management;
-using System.Net.NetworkInformation;
 using HeuristicLab.Clients.Hive.SlaveCore.Properties;
 
@@ -133,6 +132,5 @@
       try {
         prog = jobManager.GetExecutionTimes();
-      }
-      catch (Exception ex) {
+      } catch (Exception ex) {
         SlaveClientCom.Instance.LogMessage(string.Format("Exception was thrown while trying to get execution times: {0}", ex.Message));
       }
@@ -140,14 +138,18 @@
     }
 
+    /// <summary>
+    /// Returns the unique machine id of the slave
+    /// </summary>
+    /// <returns><see cref="Guid"/></returns>
     public static Guid GetUniqueMachineId() {
-      Guid id;
-      try {
-        id = GetUniqueMachineIdFromMac();
-      }
-      catch {
-        // fallback if something goes wrong...        
-        id = new Guid(Environment.MachineName.GetHashCode(), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
-      }
-      return id;
+      // Due to the fact that repeated calculation of the machine ID can lead to a client registering at 
+      // the Hive server multiple times with different IDs it's better to set the unique machine id only 
+      // once, at first startup, and store it in core settings. 
+      if (Settings.Default.MachineId == Guid.Empty) {
+        Settings.Default.MachineId = Guid.NewGuid();
+        Settings.Default.Save();
+      }
+
+      return Settings.Default.MachineId;
     }
 
@@ -170,48 +172,4 @@
     }
 
-    /// <summary>
-    /// Generate a guid based on mac address of the first found nic (yes, mac addresses are not unique...)
-    /// and the machine name.
-    /// Format:
-    /// 
-    ///  D1      D2  D3  Res.   D4
-    /// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-    /// |n a m e|0 0|0 0|0 0 mac address|
-    /// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-    /// 
-    /// The mac address is saved in the last 48 bits of the Data 4 segment 
-    /// of the guid (first 2 bytes of Data 4 are reserved).
-    /// D1 contains the hash of the machinename. 
-    /// </summary>    
-    private static Guid GetUniqueMachineIdFromMac() {
-      //try to get a real network interface, not a virtual one 
-      NetworkInterface validNic = NetworkInterface.GetAllNetworkInterfaces()
-                      .FirstOrDefault(x =>
-                                  !x.Name.Contains(vmwareNameString) &&
-                                  !x.Name.Contains(virtualboxNameString) &&
-                                  (x.NetworkInterfaceType == NetworkInterfaceType.Ethernet ||
-                                   x.NetworkInterfaceType == NetworkInterfaceType.GigabitEthernet));
-
-      if (validNic == default(NetworkInterface)) {
-        validNic = NetworkInterface.GetAllNetworkInterfaces().First();
-      }
-
-      byte[] addr = validNic.GetPhysicalAddress().GetAddressBytes();
-      if (addr.Length < macLength || addr.Length > macLongLength) {
-        throw new ArgumentException(string.Format("Error generating slave UID: MAC address has to have a length between {0} and {1} bytes. Actual MAC address is: {2}",
-              macLength, macLongLength, addr));
-      }
-
-      if (addr.Length < macLongLength) {
-        byte[] b = new byte[8];
-        Array.Copy(addr, 0, b, 2, addr.Length);
-        addr = b;
-      }
-
-      // also get machine name and save it to the first 4 bytes                
-      Guid guid = new Guid(Environment.MachineName.GetHashCode(), 0, 0, addr);
-      return guid;
-    }
-
     private static long? GetWMIValue(string clazz, string property) {
       ManagementClass mgtClass = new ManagementClass(clazz);
@@ -223,6 +181,5 @@
             try {
               return long.Parse(prop.Value.ToString());
-            }
-            catch {
+            } catch {
               return null;
             }
@@ -241,6 +198,5 @@
       try {
         mb = (int)(memCounter.NextValue() / 1024 / 1024);
-      }
-      catch { }
+      } catch { }
       return mb;
     }
@@ -251,6 +207,5 @@
       try {
         return cpuCounter.NextValue();
-      }
-      catch { }
+      } catch { }
       return cpuVal;
     }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Clients.Hive.Slave/3.3/Properties/Settings.settings	(revision 17409)
@@ -78,4 +78,7 @@
       <Value Profile="(Default)">00:05:00</Value>
     </Setting>
+    <Setting Name="MachineId" Type="System.Guid" Scope="User">
+      <Value Profile="(Default)">00000000-0000-0000-0000-000000000000</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.CodeEditor/3.4/CodeEditor.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.CodeEditor/3.4/CodeEditor.cs	(revision 17409)
@@ -282,5 +282,5 @@
     public override void ScrollToPosition(int line, int column) {
       var segment = GetSegmentAtLocation(line, column);
-      TextEditor.CaretOffset = segment.Offset + segment.Length;
+      TextEditor.CaretOffset = segment.Offset;
       TextEditor.ScrollToLine(line);
     }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Common/3.3/DoubleExtensions.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Common/3.3/DoubleExtensions.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Common/3.3/DoubleExtensions.cs	(revision 17409)
@@ -23,10 +23,28 @@
 namespace HeuristicLab.Common {
   public static class DoubleExtensions {
+    /// <summary>
+    /// Compares the similarity of value x and value y with a precision of 1.0E-12.
+    /// </summary>
+    /// <param name="x">First double value to be checked</param>
+    /// <param name="y">Second double value to compare with</param>
+    /// <returns>true if the difference is <= 1.0E-12</returns>
     public static bool IsAlmost(this double x, double y) {
+      var epsilon = 1.0E-12;
+      return IsAlmost(x, y, epsilon);
+    }
+
+    /// <summary> 
+    /// Compares the similarity of value x and value y with a given precision (epsilon).
+    /// </summary>
+    /// <param name="x">First double value to be checked</param>
+    /// <param name="y">Second double value to compare with</param>
+    /// <param name="epsilon">Error term to specify the precision</param>
+    /// <returns>true if the difference is <= epsilon</returns>
+    public static bool IsAlmost(this double x, double y, double epsilon) {
       if (double.IsInfinity(x)) {
         if (x > 0) return double.IsPositiveInfinity(y);
         else return double.IsNegativeInfinity(y);
       } else {
-        return Math.Abs(x - y) < 1.0E-12;
+        return Math.Abs(x - y) < epsilon;
       }
     }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Data/3.3/Interfaces/ITextValue.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Data/3.3/Interfaces/ITextValue.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Data/3.3/Interfaces/ITextValue.cs	(revision 17409)
@@ -20,9 +20,8 @@
 #endregion
 
-using System;
-using HeuristicLab.Common;
+using HEAL.Attic;
 
 namespace HeuristicLab.Data {
-  public interface ITextValue : IStringConvertibleValue {
-  }
+  [StorableType("6fe7970b-66de-4dcf-aa2b-c1aa9d7da29f")]
+  public interface ITextValue : IStringConvertibleValue { }
 }
